<?php

Class Matrix extends Register{

	function Matrix(){
     /* Class constructor */
    }
    /* Class varriables */
    var $posOrigine; //The Sponsor position
    var $posOrigineLevel; //The Sponsor level
    var $posMember;       // The member position
    var $posMemberLevel;  // The member level
    var $rangeLow;        // first possible position on a member given level
    var $rangeHigh;       // last possible position on a member given level
    var $rangeItem;       // number of position on a member given level
    var $cdb;

	function Matrix_insertion($MemID, $SponsorId){
		// The insertion must be done starting with the sponsor's position.
		// Therefore we need to retreive the Position ID of the sponsor.
        $s = "SELECT PositionID, Level FROM " . TABLE_FLP . " WHERE MemberID =". $SponsorId ;

        if ( !($result = $this->cdb->sql_query($s)) ):
       		// No result the new registration has not been added

            if ( defined('DEBUG') ):
       			echo $this->cdb->sql_error();
       		endif;
		endif;
        if ( $row = $this->cdb->sql_fetchrow($result)):
        	$this->SetposOrigine($row['PositionID']);
            $this->SetposOrigineLevel($row['Level']);
        endif;
        // debug echo "here";
        $this->cdb->sql_freeresult();
        // We always start with level 1 for insertion
        // as it is on the 1st level under the sponsor
        $this->SetposMemberLevel(1);
        $this->SetRange($this->GetposOrigine(),$this->GetposMemberLevel());
        if ($this->FindInsertPoint()):
           // debug	echo "FindInsertPoint returned true" . $this->GetposMember();
            // All properties have been set to assign a matrix position and activate
            if ($this->Save_Insertion($MemID)):
            	// Return
            	return true;
            endif;
        endif;
	}

    	/* Assign a reference to the db object */
		function Setdb($Id)
   		{
    	return $this->cdb = &$Id;
   		}
		function SetRange($PosID,$LevelNum){
        //Debug echo "PosId- ". $PosID. " - Level- ". $LevelNum;
        	$rangetmp=$PosID;
       	 	for ($i=1;$i<= $LevelNum;$i++){
           	 	$rangetmp = $rangetmp * MATRIX_WIDTH + 1;
        	}
        	$this->rangeLow= $rangetmp;
        	$this->rangeHigh = $this->rangeLow +  pow(MATRIX_WIDTH,$LevelNum) -1;

        	$this->rangeItem = pow(MATRIX_WIDTH,$LevelNum);
			//return "WHERE PosID >=".$rangeLow . " AND PosID <= ".$rangeHigh;
   		}

    	function FindInsertPoint(){
    		// For better performance this function should verify
        	// the number of record in the range.
        	// if the value returned is smaller then rangeItem
        	// Then we must find the first missing number.
            $PositionFound = 0;
            // Since there is no limit how deep a member is inserted
            // We will not exit until we have found a position
            while ($PositionFound <= 0):
                // The the rangelow position must be use to initialize the
                // varriable use for comparing with the rows in the recordset
                $currentPosId = $this->rangeLow;
                // debug echo "currentPosId: " . $currentPosId;
                // debug echo "rangeLow:".  $this->rangeLow;
                // debug echo "rangeHigh:".  $this->rangeHigh;
                // debug echo "rangeItem:".  $this->rangeItem;
                // debug echo "positionfound: ". $PositionFound ;
            	$sSQL = "SELECT PositionID FROM ". TABLE_FLP . " WHERE (Status=1 AND Activated=1) AND (PositionID >=". $this->rangeLow ." AND PositionID <=". $this->rangeHigh . ") ORDER BY PositionID;";
                 // debug echo $sSQL ;
        		// run the query
				if ( !($result = $this->cdb->sql_query($sSQL)) ):
       				// No result the level is empty
                	// the lower range position will be the position for this member
                    $PositionFound =  $currentPosId;
                    // debug echo "PositionFound:" . $PositionFound ;
                   // debug echo "in if no result positionfound: ". $PositionFound ;
                    break;
       				if ( defined('DEBUG') ):
       					echo $this->cdb->sql_error();
       				endif;
				endif;
            	$reccount= $this->cdb->sql_numrows($result);
                // debug  echo "recordCount: ".$reccount;
        		//how many records for this level
                if ($reccount == 0):
                	// On some platform the above code for an empty record will not work
                   // echo "in if reccount ==0 positionfound: ". $PositionFound ;
                    // therefore we need this verification
                    $PositionFound =  $currentPosId;
        		elseif ($reccount < $this->rangeItem):
           			// The level is not complete. We need to find the first empty positon
                	if ( $row =  $this->cdb->sql_fetchrow($result)):
                        if ($row['PositionID'] > $this->GetRangeLow()):
                        	// If the first position in the recordset is greater then
                            // the lower range this is a special case
                            // where the begining of the row is missing
                            $PositionFound = $currentPosId;
                            $this->SetposMember($PositionFound);
                            $this->cdb->sql_freeresult();
            				return true;
                        endif;
                        // Looping on the recordset will give us
                        //the first missing position in a level
						do

							if ($row['PositionID'] > $currentPosId+1):
								// We have found the missing position
                               //	$PositionFound = ($currentPosId == $this->GetRangeLow()? $currentPosId : $currentPosId+1);
                                $PositionFound = $currentPosId+1;
                                // debug echo "row:". $row['PositionID'];
                                // debug echo "CurPos = lowrange:" .($currentPosId == $this->GetRangeLow()? $currentPosId : $currentPosId+1);
                            	break;
                        	else:
                            	// We need to update the currentPosId
                                //for the next execution
                                // debug echo "else row:". $row['PositionID'];
                            	$currentPosId = $row['PositionID'];
                                // debug echo "else row2 :". $row['PositionID'];
                        	endif;

						while ( $row =  $this->cdb->sql_fetchrow($result) );
                        // This Prvious loop takes care of finding a missing position
                        // in the level but it will not take care of the end of a row
                        //
                        // debug echo "out of the loop";
                        if ($PositionFound == 0 && $currentPosId < $this->rangeHigh):
                            $PositionFound = $currentPosId +1;
                        endif;

                	endif;
        		else:
           			// The level is complete.
                    // Therefore the member to be inserted
                    //will be one more level down from his sponsor
                    $this->SetposMemberLevel($this->Add_Level($this->GetposMemberLevel()));
                    //We need to set range varriables to query the next level
                    $this->SetRange($this->GetposOrigine(),$this->GetposMemberLevel());
        		endif;
                $this->cdb->sql_freeresult();
        	endwhile;
            // We have exited the outer loop therefore we have found the member position
            $this->SetposMember($PositionFound);
            return true;
    	}
    	function CountOnLevel(){
    		// Use to return the number of positions on a given level
        	// As the number of members to return is on 10 levels
            // The range must be set for the 10 levels starting with the position
            // of the member for whom we are counting.
            $sRange = $this->SetSQLRange10Level();

            $s = "SELECT Level, count('UserID')  AS 'mycount' FROM `" . TABLE_FLP ."`";
			$s .= " WHERE (Activated =1 and Status=1) AND (". $sRange . ")";
			$s .= " GROUP BY 'Level'";
        	// run query
			if ( !($result = $this->cdb->sql_query($s)) ):
       			// No result the Matrix is empty
       			if ( defined('DEBUG') ):
       				echo $this->cdb->sql_error();
       			endif;
                $this->cdb->sql_freeresult();
            else:
                // Built the array of subscriber per level
                if ( $row =  $this->cdb->sql_fetchrow($result)):
                	do {
                    	$Arr_count[]=$row['mycount'];
                    } while ( $row =  $this->cdb->sql_fetchrow($result) );
                endif;
                $this->cdb->sql_freeresult();
            	return $Arr_count;
			endif;
    	}

        /* Create an SQL string to query 10 level */
        function SetSQLRange10Level(){
        	$sRang= "";
            for ($l = 1; $l<=10; $l++){
                $this->SetRange($this->GetPosMember(),$l);
                if ($sRang <> ""):
                    $sRang .= " OR";
                endif;
                $sRang .= " (PositionID >=". $this->GetRangeLow(). " AND PositionID <=" .$this->GetRangeHigh(). ")";
            }
            return $sRang;
        }
        /* Update the member record with the position and level value */
        function Save_Insertion($ID){
            //we need to add the sponsor's level to the level of this new member
            // to reflect the real level in the over all matrix
        	$reallevel = $this->GetposMemberLevel()+ $this->GetposOrigineLevel();
        	$s = "UPDATE " . TABLE_FLP . " SET PositionID=" . $this->GetposMember();
            $s .= ", Level=" . $reallevel ;
            $s .= ", Activated=1, Status=1 WHERE MemberID=".$ID;
            // debug echo $s;
            // run the query
			if ( !($result = $this->cdb->sql_query($s)) ):
       			// No result the level is empty
               	// the lower range position will be the position for this member
       			if ( defined('DEBUG') ):
       				echo $this->cdb->sql_error();
       			endif;
                $this->cdb->sql_freeresult();
                return false;
            else:
            	$this->cdb->sql_freeresult();
            	return true;
			endif;
        }
        function GetRangeLow(){
        	return $this->rangeLow;
        }
         function GetRangeHigh(){
        	return $this->rangeHigh;
        }
        function Add_Level($l){
        	return $l +1;
        }
        function GetposMemberLevel() {
        	return $this->posMemberLevel;
        }

        function SetposMemberLevel($l){
        	$this->posMemberLevel= $l;
        }
        function GetposMember(){
        	return $this->posMember;
        }
        function SetposMember($p){
        	$this->posMember = $p;
        }

        function GetposOrigine(){
        	return $this->posOrigine;
        }

        function SetposOrigine($p){
        	$this->posOrigine= $p;
        }

        function GetposOrigineLevel(){
        	return $this->posOrigineLevel;
        }

        function SetposOrigineLevel($l){
        	$this->posOrigineLevel=$l;
        }
        /* Retrieve the position ID for a given member from the Database */
        function SetposMemberFromDB($ID){
        	$s ="SELECT PositionID FROM " . TABLE_FLP . " WHERE MemberID =". $ID ;

        if ( !($result = $this->cdb->sql_query($s)) ):
       		// No result this is because the ID is wrong.

            if ( defined('DEBUG') ):
       			echo $this->cdb->sql_error();
       		endif;
		endif;
        if ( $row = $this->cdb->sql_fetchrow($result)):
        	$this->SetposMember($row['PositionID']);
        endif;
        $this->cdb->sql_freeresult();
        if (($this->GetposMember() > 0) && ($ID <> DEF_SPONSORID)):
        	return true;
        elseif (($this->GetposMember() == 0) && ($ID == DEF_SPONSORID)):
            return true;
        else:
        	return false;
        endif;
        }
        /* Display the matrix or down line */
        function Show_DownLine(){
            $s = '';

            $CntSub=$this->CountOnLevel();
            $s.='<table cellspacing="2" cellpadding="2">';
            $s .= '<tr align="center"><td colspan=2 class="flp"><b>Your Downline</b></td></tr>';
            $s .='<tr align="center"><td  class="flp"><b>Levels</b></td><td  class="flp"><b>Subscribers</b></td>';
            $CntTotal = 0;
            for ($i=1; $i<=10;$i++){
            	$s .= '<tr><td  class="flp">'.$i . '</td><td align="right"  class="flp">'. ((count($CntSub)> $i-1 ) ? $CntSub[$i-1] : 0).'</td></tr>';
                $CntTotal += $CntSub[$i-1];
            }
            $s .= '<tr><td  class="flp">Total</td><td align="right"  class="flp">'. $CntTotal.'  Subscribers</td></tr>';

            $dir_ref = $this->CntDir_ref($_SESSION["MemberID"]);
            $s .= '<tr><td  class="flp">Total</td><td align="right"  class="flp">'. $dir_ref .'&nbsp;&nbsp;Direct referral</td></tr>';
            $s .= '</table>';
            return $s;
        }

        function CntDir_ref($Id){
        	$the_count=0;
        	$sSQL = 'SELECT COUNT(SponsorID) as cntRef FROM ' . TABLE_FLP . ' WHERE SponsorID='.$Id;
            if ( !($result = $this->cdb->sql_query($sSQL)) ):
       			// No result no direct referral
       			if ( defined('DEBUG') ):
       				echo $this->cdb->sql_error();
       			endif;
                $this->cdb->sql_freeresult();
                return $the_count;
            else:
                // Built the array of subscriber per level
                if ( $row =  $this->cdb->sql_fetchrow($result)):
                	$the_count =$row['cntRef'];
                endif;
                $this->cdb->sql_freeresult();
            	return $the_count;
			endif;
        }

        function Cnt_mail_to_send(){
        	$CntSub=$this->CountOnLevel();
            $CntTot = 0;
            if ($CntSub):
            foreach ($CntSub as $value){
            	$CntTot += $value;
            }
            endif;
            return $CntTot. ' <b>Subscribers including '. $this->CntDir_ref($_SESSION["MemberID"]) . ' direct referrals</b>';
		}

        function Mailing_AddressesSQL($MId){
            if ($this->SetposMemberFromDB($MId)):
            	$sRange  = $this->SetSQLRange10Level();
            endif;
         	$s = "SELECT FirstName,EMail FROM `". TABLE_FLP ."`";
			$s .= " WHERE (Activated =1 and Status=1) AND ((". $sRange . ") OR SponsorID = ". $MId ;
			$s .= ") GROUP BY 'EMail'";
            return $s;
        }

} //end class
?>